/*
 * $Id: EMailMessage.java,v 1.4 2000/09/20 05:05:59 brydon Exp $
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs.
 */

package com.sun.j2ee.blueprints.mail.ejb;


/**
 * This class encapsulates all the info need to send an email
 * message. This object is passed to the MailerEJB
 * sendMail(...) method.
 */
public class EMailMessage implements java.io.Serializable {

    private String subject;
    private String htmlContents;
    private String emailReceiver;

    public EMailMessage( String subject, String htmlContents,
                                         String emailReceiver) {
        this.subject       = subject;
        this.htmlContents  = htmlContents;
        this.emailReceiver = emailReceiver;
    }

    //subject field of email message
    public String getSubject() {
        return subject;
    }

    //Email address of recipient of email message
    public String getEmailReceiver() {
        return emailReceiver;
    }

    //contents of email message
    public String getHtmlContents() {
        return htmlContents;
    }

    public String toString() {
        return subject + " " +  emailReceiver + " " + htmlContents;
    }
}

