/*
 * $Id: MailerEJB.java,v 1.7 2000/09/20 05:05:59 brydon Exp $
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs.
 */

package com.sun.j2ee.blueprints.mail.ejb;

import java.rmi.RemoteException;

import javax.ejb.EJBException;
import javax.ejb.FinderException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;



/**
 *  Session Bean implementation of MailerEJB.
 *  Used to send a confirmation email to a customer
 *  after a purchase is completed.
 *  This functionality is enabled by modifying the
 *  sendConfirmationMail property at deployment time.
 *
 *  @see MailHelper
 *  @see com.sun.estore.control.ejb.StateMachine
*/

public class MailerEJB implements SessionBean {

    private MailHelper mailHelper;

    public void ejbCreate() {}

    public void setSessionContext(SessionContext sc) {}

    public void ejbRemove() {}

    public void ejbActivate() {}

    public void ejbPassivate() {}

    /**
     * This method creates an email confirmation message
     * for an order and sends an email to the customer.
     *
     * @param  eMess  content  for the email message for a particular
     *                  order
     */
    public void sendMail(EMailMessage eMess) throws SendMailException {
                getMailHelper().createAndSendMail(eMess);
    }

    private MailHelper getMailHelper() {
        mailHelper = new MailHelper();
        return mailHelper;
    }
}
