/*
 * $Id: JNDINames.java,v 1.8 2000/10/06 15:53:36 lblair Exp $
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs.
 */

package com.sun.j2ee.blueprints.petstore.util;

/**
 * This class is the central location to store the internal
 * JNDI names of various entities. Any change here should
 * also be reflected in the deployment descriptors.
 */
public interface JNDINames {

    //
    // JNDI names of EJB home objects
    //
    public static final String CATALOG_EJBHOME = "java:comp/env/ejb/catalog";
    /** JNDI name of the home interface of ShoppingClientController EJB */
    public static final String SCC_EJBHOME = "java:comp/env/ejb/scc";
    /** JNDI name of the home interface of ShoppingCart */
    public static final String CART_EJBHOME = "java:comp/env/ejb/cart";
    public static final String PROFILEMGR_EJBHOME = "java:comp/env/ejb/profilemgr";
    public static final String CUSTOMER_EJBHOME = "java:comp/env/ejb/customer";
    public static final String ORDER_EJBHOME = "java:comp/env/ejb/order";
    public static final String INVENTORY_EJBHOME = "java:comp/env/ejb/inventory";
    public static final String MAILER_EJBHOME = "java:comp/env/ejb/mailer";
    //
    // JNDI Names of data sources.
    //
    public static final String INVENTORY_DATASOURCE =
        "java:comp/env/jdbc/InventoryDataSource";
    public static final String ESTORE_DATASOURCE =
        "java:comp/env/jdbc/EstoreDataSource";

    //
    // JNDI Names of other resources.
    //
    public static final String MAIL_SESSION = "java:comp/env/mail/MailSession";

    //
    // JNDI Names of application properties.
    //
    public static final String SECURITY_ADAPTER_CLASSNAME =
        "java:comp/env/securityAdapterClassName";
    public static final String SERVER_TYPE =
        "java:comp/env/serverType";
    public static final String SEND_CONFIRMATION_MAIL =
        "java:comp/env/sendConfirmationMail";
}
